﻿using System;
using System.Xml;

using X = Microsoft.Xna.Framework;
using XCP = Microsoft.Xna.Framework.Content.Pipeline;
using XCPG = Microsoft.Xna.Framework.Content.Pipeline.Graphics;

namespace XNA.BLEND {
  [XCP.ContentImporter( @".blend", CacheImportedData = true, DefaultProcessor = @"ModelProcessor" )]
  public class BlendImporter : XCP.ContentImporter<XCPG.NodeContent> {
    public override XCPG.NodeContent Import( string filename, XCP.ContentImporterContext context ) {
      XCP.ContentIdentity id = new XCP.ContentIdentity( filename );
      id.SourceTool = @"BlendImporter";

      parser.BlendParser p = new parser.BlendParser();

      XCPG.NodeContent result = p.Parse( filename, context, id );
      result.Identity = id;

      return result;
    }
  }
}
